(* Time-stamp: <modified the 30/04/2019 (at 16:02) by Erwan Jahier> *)

(** There is such a Process.t per node in the dot file. *)
type t = {
  pid : string; (* unique *)
  variables : Algo.vars;
  actions: Algo.action list;
  init : Algo.neighbor list -> Algo.local_env;
  enable : Algo.enable_fun;
  step : Algo.step_fun;
}

(** [make dynlink_flag custom_mode_flag node] builds a process out of a dot
   node. To do that, it retreives the registered functions by Dynamic
   linking of the cmxs file specified in the "algo" field of the dot
   node.

    dynlink_flag: link the algo.cmxs files (not possible from rdbg) 

    nb: it provides variable initial values if not done in the dot
   (via the init field) nor in the Algo (via Algo.reg_init_vars) *)
val make: bool -> bool -> Topology.node -> t
